# -*- coding: utf-8 -*-
from setuphelpers import *
import psutil
import time
import threading

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
app_uninstallkey = "{82442898-8FE9-44E8-8F50-D2EACBB80848}"
kb_fname = "Windows6.1-KB3033929-x64.msu"


def install():
    # Declaring local variables
    package_version = control.get_software_version()
    bin_name = glob.glob("*seadrive*.exe")[0]
    app_name = control.name

    if need_install(key=app_uninstallkey, min_version=package_version):
        # if windows_version() >= WindowsVersions.Windows7 and windows_version() < WindowsVersions.Windows8:
        #    if not is_kb_installed('KB3033929'):
        #        print('Instaling required KB3033929')
        #        with EnsureWUAUServRunning():
        #            # 2359302 : patch already installed
        #            run('wusa.exe /quiet /norestart %s' % kb_fname,accept_returncodes=[0,3010,2359302])
        #    else:
        #        print('Skipping install of KB3033929')

        # Installing the package
        # if not is_pending_reboot():
        print("Installing: %s" % bin_name)
        install_exe_if_needed(
            bin_name,
            key=app_uninstallkey,
            silentflags="/install /passive /quiet /norestart",
            min_version=package_version,
            accept_returncodes=[0, 3010, 1638, 1641],
        )
        uninstallkey.remove(app_uninstallkey)
    # else:
    #    error("ERROR: Installation cannot continue since this PC is in pending reboot state.")
    else:
        print("%s is already installed and up-to-date" % app_name)


def uninstall():

    # Uninstalling the SeaDrive dependency called Dokan Library
    for uninstall in installed_softwares("Dokan Library"):
        print("Removing: %s" % uninstall["name"])
        run(uninstall_cmd(uninstall["key"]))

    # Uninstalling SeaDrive
    for uninstall in installed_softwares("SeaDrive"):
        if uninstall["key"] == app_uninstallkey:
            continue
        print("Removing: %s" % uninstall["name"])
        t = threading.Thread(target=killseadrive)
        t.start()
        run(uninstall_cmd(uninstall["key"]))


def session_setup():
    print("Disabling auto-update check and configuring base options")
    registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\Seafile\Seafile Drive Client\WinSparkle", "CheckForUpdates", "0")
    registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\SeaDrive\Seafile Drive Client\Language", "current", "en")
    registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\SeaDrive\Seafile Drive Client\Misc", "SparkleAlreadyEnableUpdateByDefault", "true")
    registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\SeaDrive", "ShellExtDisabled", "1")
    registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\SeaDrive\Seafile Drive Client\Settings", "diskLetter", "S:")
    if not reg_value_exists(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "SeaDrive"):
        print("Now auto starting SeaDrive after login")
        app_exe = makepath(programfiles32, "SeaDrive", "bin", "seadrive-gui.exe")
        registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "SeaDrive", app_exe)
        if not isrunning("seadrive-gui.exe"):
            # run(app_exe, wait=False)
            psutil.Popen([app_exe])
            print("You may need to manually run SeaDrive for the first time")


def is_pending_reboot():
    r"""Check whether operating system is on pending reboot

    Returns:
        boolean

    >>> is_pending_reboot()
    True
    """

    if (
        reg_key_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\RebootRequired")
        or reg_key_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\RebootPending")
        or reg_value_exists(HKEY_LOCAL_MACHINE, r"SYSTEM\CurrentControlSet\Control\Session Manager", "PendingFileRenameOperations")
        or reg_value_exists(HKEY_LOCAL_MACHINE, r"SYSTEM\CurrentControlSet\Control\Session Manager", "PendingFileRenameOperations2")
        or reg_key_exists(HKEY_LOCAL_MACHINE, r"SOFTWARE\Microsoft\Updates\UpdateExeVolatile")
    ):
        return True
    return False


def killseadrive():
    time.sleep(15)
    killalltasks("seadrive-gui.exe")
    time.sleep(15)
    killalltasks("seadrive-gui.exe")
    time.sleep(15)
    killalltasks("seadrive-gui.exe")
